#include <iostream>
 
/*
 * Bartosz "WiedMAC" Bednarczyk
 * Liceum Oglnoksztacce im. Wadysawa Broniewskiego w Strzelcach Opolskich
 * Obliczanie interacyjnie elementu cigu fibonacciego dla duych liczb  
 * www.algorytm.org
 */
 
inline int Cyfra( char znak )  { return int(znak-48);    }      // Funckcja zamieniajca znak na cyfr
 
inline char Znak( int Liczba ) { return char(Liczba+48); }      // Funkcja zamieniajca cyfr na znak
 
std::string Dodawanie( std::string &A, std::string &B )
{     
       while( A.length() != B.length() )        // Porwnywanie dugoci stringw
       {
              if( A.length() > B.length() )     // Jeeli ktry z nich jest mniejszy to dodajemy zera
              {
                   B = "0" + B;
              }
              else A = "0" + A;
       }
       
       std::string Wynik = "";  // Wynik dodawania
       int Pomocnicza = 0;      // Zmienna pomocnicza
       
       for(int i = A.length()-1; i >= 0; i-- )  // Waciwa procedura dodawania
        {
               int Pom = Cyfra(A[i]) + Cyfra(B[i]) + Pomocnicza;        // Obliczamy sum kolejnych cyfr cigu
               Wynik = Znak( Pom % 10 ) + Wynik;                        // Zapisujemy j do zmiennej Wynik
               Pomocnicza = int(Pom/10);
       }
       
       if( Pomocnicza != 0 ) Wynik = Znak( Pomocnicza ) + Wynik;        // Jeeli co zostao, to dodajemy na pocztek
       
       return Wynik;
}
 
int main()
{
        std::ios_base::sync_with_stdio(false);    // Przypieszenie I/O
        
        std::string Fib0 = "0", Fib1 = "1", FibN;       // Elementy cigu Fibonacciego
        
        unsigned long long int N, i;    
        
        std::cout << "Ktory element ciagu obliczyc?\n";
        std::cin >> N;
        
        if( N < 2 )
        {
                if( N == 0 ) FibN = Fib0;
                else FibN = Fib1;
        }
        else
        {
                for( i = 2; i <= N; i++ )       // Obliczanie elementu cigu fibonacciego
                {
                        FibN = Dodawanie( Fib0, Fib1 );
                        Fib0 = Fib1;
                        Fib1 = FibN;
                }
        }
        
        std::cout << "Fib(" << N << ") = " << FibN << "\n";     // Wypisywanie wyniku
        
        return 0;
}